package com.tae.sadcafek.parsingweather;

import java.io.IOException;
import java.io.InputStream;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.ArrayList;
import org.xmlpull.v1.XmlPullParser;
import org.xmlpull.v1.XmlPullParserException;
import org.xmlpull.v1.XmlPullParserFactory;

import android.util.Log;

public class Parser {
	private String TAG = "Parser";
	ArrayList<WeatherForecast> parseWeather;
	
	Parser() {
		parseWeather = new ArrayList<WeatherForecast>();
	}
	
	ArrayList<WeatherForecast> parseWeather() {
		try {
			String url = "http://www.google.com/ig/api?hl=ko&weather=seoul";
			URL targetURL = new URL(url);
			
			InputStream is = targetURL.openStream();
			
			//Parser
			XmlPullParserFactory factory = XmlPullParserFactory.newInstance();
			XmlPullParser parser = factory.newPullParser();
			
			parser.setInput(is, "euc-kr");
		
			String tag;
			WeatherForecast wf = null;
			int parserEvent = parser.getEventType();
			while(parserEvent != XmlPullParser.END_DOCUMENT) {
				Log.d(TAG, "hi");
				switch(parserEvent) {
				case XmlPullParser.END_TAG:
					tag = parser.getName();
					Log.d(TAG, "END_TAG");
					if(tag.compareTo("forecast_conditions") == 0) {
						parseWeather.add(wf);
						Log.d(TAG, "/forecast_conditions");
					}
					break;
				case XmlPullParser.START_TAG:
					tag = parser.getName();
					Log.d(TAG, "START_TAG : " + tag);
					if(tag.compareTo("forecast_conditions") == 0) {
						wf = new WeatherForecast();
					} else if(wf != null && tag.compareTo("day_of_week") == 0) {
						wf.dayOfWeek = parser.getAttributeValue(null, "data");
						Log.d(TAG, wf.dayOfWeek);
					} else if(wf != null && tag.compareTo("low") == 0) {
						wf.low = parser.getAttributeValue(null, "data");
					} else if(wf != null && tag.compareTo("high") == 0) {
						wf.high = parser.getAttributeValue(null, "data");
					} else if(wf != null && tag.compareTo("icon") == 0) {
						wf.icon = parser.getAttributeValue(null, "data");
					} else if(wf != null && tag.compareTo("condition") == 0) {
						wf.condition = parser.getAttributeValue(null, "data");
					}
					break;
				}
				parserEvent = parser.next();
			}
			
		} catch (MalformedURLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (XmlPullParserException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		return parseWeather;		
	}
}
