package com.tae.sadcafek.parsingweather;

import java.io.BufferedInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.net.URLConnection;
import java.util.ArrayList;
import java.util.List;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.AsyncTask;
import android.os.Handler;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.TextView;

public class WeatherAdapter extends ArrayAdapter<WeatherForecast> {
	private View v;
	private ViewHolder holder;
	private Handler mHandler;

	public WeatherAdapter(Context context, int resource,
			List<WeatherForecast> objects) {
		super(context, resource, objects);
	}

	@Override
	public View getView(int position, View convertView, ViewGroup parent) {
		// TODO Auto-generated method stub
		if (convertView == null) {
			LayoutInflater inflater = LayoutInflater.from(getContext());
			v = inflater.inflate(R.layout.list_item_1, null);
			holder = new ViewHolder();
			holder.dayOfWeek = (TextView) v.findViewById(R.id.dayOfWeek);
			holder.high = (TextView) v.findViewById(R.id.high);
			holder.low = (TextView) v.findViewById(R.id.low);
			holder.condition = (TextView) v.findViewById(R.id.condition);
			holder.imgView = (ImageView) v.findViewById(R.id.imgView);
			v.setTag(holder);
		} else {
			v = convertView;
			holder = (ViewHolder) v.getTag();
		}

		final WeatherForecast wf = getItem(position);
		holder.dayOfWeek.setText(wf.dayOfWeek);
		holder.high.setText(wf.high);
		holder.low.setText(wf.low);
		holder.condition.setText(wf.condition);
		new ImageAsync(holder.imgView).execute(wf.icon);
	
		return v;
	}
}

class ImageAsync extends AsyncTask<String, String, ImageView> {
	Bitmap bm;
	ImageView mImg;
	
	ImageAsync(ImageView img) {
		mImg = img;
	}

	@Override
	protected ImageView doInBackground(String... params) {
		try {
			URL url = new URL("http://www.google.com" + params[0]);
			Log.d("TA", params[0]);
			URLConnection connection = url.openConnection();
			connection.connect();
			InputStream is = connection.getInputStream();
			BufferedInputStream bis = new BufferedInputStream(is);
			bm = BitmapFactory.decodeStream(bis);
			bis.close();
			is.close();
		} catch (IOException e) {
			// TODO: handle exception
		}
		return null;
	}
	
	@Override
	protected void onPostExecute(ImageView imgView) {
		mImg.setImageBitmap(bm);
	}
}

class ViewHolder {
	TextView dayOfWeek;
	TextView high;
	TextView low;
	TextView condition;
	ImageView imgView;
}
